//+------------------------------------------------------------------+
//|                                                WPR_Level_Ind.mq4 |
//|                                       Copyright  2007, Moriarty |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Moriarty"
#property link      "Moriarty@nm.ru"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Gold
#property indicator_color2 Aqua
#property indicator_color3 Red

extern int    T3       = 8;
extern double b        = 0.618;
extern int    Per      = 89;
extern int    mBar     = 300;
extern int    Sdvig    = 0;
extern int    TF       = 0; // 0 - 
extern bool   Comments = false;   // 

double WPR[],LevelUp[],LevelDn[],dist,H,L,LH,LL,e1,e2,e3,e4,e5,e6,c1,c2,c3,c4,n,w1,w2,b2,b3,wpr; int i,ft,N,blUp,blDn; string txt;
//+------------------------------------------------------------------+
void init() { SetIndexStyle(0,12,0); SetIndexBuffer(0,WPR); SetIndexEmptyValue(0,EMPTY_VALUE);// dist=NormalizeDouble(Distance*Point,Digits);
   SetIndexStyle(1,3,0); SetIndexBuffer(1,LevelUp); SetIndexEmptyValue(1,EMPTY_VALUE); SetIndexArrow(1,159);
   SetIndexStyle(2,3,0); SetIndexBuffer(2,LevelDn); SetIndexEmptyValue(2,EMPTY_VALUE); SetIndexArrow(2,159); }
//+------------------------------------------------------------------+
void deinit() { if(Comments) Comment(""); }
//+------------------------------------------------------------------+
void start() { if(ft==0) { ft=1;    b2=b*b; b3=b2*b; c1=-b3; c2=(3*(b2+b3)); c3=-3*(2*b2+b+b3);
   c4=(1+3*b+b3+3*b2); n=T3; if(n<1) n=1; n=1+0.5*(n-1); w1=2/(n+1); w2=1-w1; }
   for(i=Bars-1; i>=0; i--) { WPR[i]=0; }
   
   for(i=mBar; i>=0; i--) { wpr=iWPR(NULL,TF,Per,i);
   e1=w1*wpr+w2*e1; e2=w1*e1+w2*e2; e3=w1*e2+w2*e3; e4=w1*e3+w2*e4;
   e5=w1*e4+w2*e5; e6=w1*e5+w2*e6; WPR[i]=c1*e6+c2*e5+c3*e4+c4*e3;
   
   if(WPR[i+Sdvig]>=WPR[i+Sdvig+1]) { N=1; txt=""; }
   
   if(WPR[i+Sdvig]<=WPR[i+Sdvig+1]) { N=-1; txt=""; }
   
   if(N>0 && blUp==0) { H=High[i]; blUp=1; blDn=0; }
   if(N<0 && blDn==0) { L=Low[i]; blDn=1; blUp=0; }
   
   if(N>0 && H<High[i] && blUp==1) H=High[i];
   if(N<0 && L>Low[i] && blDn==1) L=Low[i];
   
   if(blDn==0) LevelDn[i]=L; if(LevelDn[i]==EMPTY_VALUE) LevelDn[i]=LevelDn[i+1];
   if(blUp==0) LevelUp[i]=H; if(LevelUp[i]==EMPTY_VALUE) LevelUp[i]=LevelUp[i+1]; }
   
   if(Comments) Comment(txt,"   High = ",H,"   Low = ",L,"   LevelUp[0] = ",LevelUp[0],"   LevelDn[0] = ",LevelDn[0],"   WPR =",WPR[0]); }
//+------------------------------------------------------------------+